#ifndef SCORE_H
#define SCORE_H

#include <stdint.h>
#include "board.h"
#include "game.h"

#define CHECKMATE 32000
#define STALEMATE     0
#define ILLEGAL   (CHECKMATE+500)

static inline bool is_mate_score(int score)
{
   static const int mate = CHECKMATE - 1000;
   if ( score > mate || score < -mate )
      return true;

   return false;
}

static inline int score_to_hashtable(int score, int depth)
{
   if (is_mate_score(score)) {
      assert(score + depth <= CHECKMATE);
      assert(score - depth >= -CHECKMATE);
      if (score > 0)
         return score + depth;
      else
         return score - depth;
   }

   return score;
}

static inline int score_from_hashtable(int score, int depth)
{
   if (is_mate_score(score)) {
      assert( (score>0 && (score - depth <=  CHECKMATE)) ||
              (score<0 && (score + depth >= -CHECKMATE)) );
      if (score > 0)
         return score - depth;
      else
         return score + depth;
   }

   return score;
}

#endif

