#include <stdint.h>
#include "assert.h"
#include "hashkey.h"
#include "genrand.h"
#include "pieces.h"

uint64_t piece_key[NUM_SIDES][MAX_PIECE_TYPES][256];
uint64_t side_to_move_key;

static uint64_t genrand64(void)
{
   return ((uint64_t)genrandui())<<32 | genrandui();
}

void initialise_hash_keys(void)
{
   sgenrand(0x1422CE55);

   for (side_t side=WHITE; side<=BLACK; side++)
      for (int piece = 0; piece < MAX_PIECE_TYPES; piece++)
         for (int square = 0; square<256; square++)
            piece_key[side][piece][square] = genrand64();

   side_to_move_key = genrand64();
}

uint64_t get_hash_key(side_t side, int piece, int square)
{
   return piece_key[side][piece][square];
}

uint64_t get_stm_hash_key(void)
{
   return side_to_move_key;
}
